// SmallMeteo parser to APRS v0.1
// http://infotex58.ru
// Огромное спасибо Михаилу aka TurangaLeela за парсер данных! Many thanks TurangaLeela!

#include <ESP8266WiFi.h>
#include <ESP8266WiFiMulti.h>
#include <ESP8266HTTPClient.h>

#define USE_SERIAL Serial
#define SLEEP_DELAY 3000

ESP8266WiFiMulti WiFiMulti;

char * skipControlChars(char * sLine) {
    char * startFrom = sLine;
 
    while(true) {
        if(nullptr == sLine) {
            break;
        }
   
        if('#' == (*sLine)) {
            if((sLine - startFrom) > 0) {
                --sLine;
            } else {
                sLine = nullptr;
            }
           
            break;
        } else if('\0' == (*sLine)) {
            sLine = nullptr;
       
            break;
        }
       
        ++sLine;
    }
   
    return sLine;
}

void setup() {

  USE_SERIAL.begin(115200); // Скорость порта 
  USE_SERIAL.flush();    
  delay(1000);
  WiFiMulti.addAP("Infotex", "12345678"); // SSID и пароль точки доступа
}


void closeConnection(HTTPClient * pClientToClose) {
  pClientToClose -> end();
  delay(SLEEP_DELAY);
}

void loop() {
  if((WiFiMulti.run() == WL_CONNECTED)) {
    HTTPClient http;
    http.begin("http://infotex58.ru:88/tiny.htm"); //Адрес и порт метеостанции
    int httpCode = http.GET();
    
    if(httpCode > 0) { 
      if(httpCode == HTTP_CODE_OK) {
        String sPayload = http.getString();
        int iIncomeStrLen = (sPayload.length() + 1);
        char sPayloadBuf[iIncomeStrLen];
        char * pchBuf;
        char * pch;
        int x = -999;
        int y = -999;
        int z = -999;
        
        sPayload.toCharArray(sPayloadBuf, iIncomeStrLen);
        pch = strtok(sPayloadBuf, ">");
  
        while(nullptr != pch) { 
          pchBuf = skipControlChars(pch);
   
          if(nullptr == pchBuf) {
            closeConnection(&http);
            break;
          }

          switch(pchBuf[0]) {
            case '3': {
              x = round((atof(pchBuf + 2) * 1.8f) + 32); 
              break;
            } case '4': { 
              y = atoi(pchBuf + 2);
              break;
            } case '5': {  
              z = (atoi(pchBuf + 2) * 10);           
              break;
            } default: {
             
              break;
            }
          }
     
          pch = strtok(nullptr, ">");
        } 

        const uint16_t port = 14580; // Указываем порт сервера
        const char * host = "194.186.45.251"; // Указываем имя хоста или его IP
        WiFiClient client; // Включаем режим WI-FI клиента
        delay(5000); // курим 5 сек

        if (!client.connect(host, port)) {
           closeConnection(&http); // Если приконектились к серверу то едим дальше иначе ждём ? сек
           
           return;
        }

        client.println("user RA4FHE-2 pass 12345 vers ESP8266_SM 0.1 filter m/1");  // Логинемся на сервер
        delay (250);
     
        const int & f = x; // Температура
        const int & h = y; // Влажность
        const int & p = z; // Давление
        
        USE_SERIAL.println(f); // смотрим в порту что получаем
        USE_SERIAL.println(h);
        USE_SERIAL.println(p);

        client.print("RA4FHE-2>APRSWX,TCPIP*,qAC,T2RUSSIA:=5312.66N/04500.72E_");     // Поехали кидать инфу на сервак (Указываем позывной и координаты)
        client.print(".../...g...");
        if (f >= 0)
        {
        client.print("t0"); client.print(f);
        }
        else
        {
        client.print("t"); client.print(f);
        }
        client.print("r...p...P...h"); client.print(h);  
        if (p >= 10000)
        {
        client.print("b"); client.print(p); client.println(" http://infotex58.ru"); // Добиваем коммент
        }
        else
        {
        client.print("b0"); client.print(p); client.println(" http://infotex58.ru"); //Добиваем коммент
        }
        client.println("RA4FHE-2>APRSWX,TCPIP*,qAC,T2RUSSIA:> SmallMeteo to APRS"); // Статус сообщение
        delay(600000); // Ждём 10 мин перед следующей отправкой пакета 
      }
    }
    
    closeConnection(&http);
  }
}
